package danielcortes.xyz.views.components;

import java.time.Year;
import javax.swing.AbstractSpinnerModel;

public class YearSpinnerModel extends AbstractSpinnerModel {

  private int value;
  private String showingValue;

  public YearSpinnerModel() {
    this.value = Year.now().getValue();
    this.showingValue = String.valueOf(value);
  }

  @Override
  public Object getValue() {
    return this.showingValue;
  }

  @Override
  public void setValue(Object value) {
    this.showingValue = String.valueOf(value);
    this.value = Integer.parseInt(this.showingValue);
  }

  @Override
  public Object getNextValue() {
    if (this.value == 9999) {
      return null;
    }

    if (this.value > 9999) {
      this.value = 9999;
      this.showingValue = String.valueOf(this.value);
    } else if (this.value < 0) {
      this.value = 0;
      this.showingValue = String.valueOf(this.value);
    } else {
      this.value++;
      this.showingValue = String.valueOf(value);
    }

    this.fireStateChanged();
    return this.showingValue;
  }

  @Override
  public Object getPreviousValue() {
    if (this.value == 0) {
      return null;
    }

    if (this.value > 9999) {
      this.value = 9999;
      this.showingValue = String.valueOf(this.value);
    } else if (this.value < 0) {
      this.value = 0;
      this.showingValue = String.valueOf(this.value);
    } else {
      this.value--;
      this.showingValue = String.valueOf(value);
    }

    this.fireStateChanged();
    return this.showingValue;
  }
}
